Debian Bug report logs - #728249
FTBFS on mips, mipsel and s390x due to -Werror=format-security

version graph

Package: mpqc; Maintainer for mpqc is Debichem Team <debichem-devel@lists.alioth.debian.org>; Source for mpqc is src:mpqc.

Reported by: Aurelien Jarno <aurel32@debian.org>

Date: Tue, 29 Oct 2013 22:21:02 UTC

Severity: serious

Tags: patch, upstream

Found in version mpqc/2.3.1-15

Fixed in version mpqc/2.3.1-16

Done: Michael Banck <mbanck@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debichem Team <debichem-devel@lists.alioth.debian.org>:
Bug#728249; Package mpqc. (Tue, 29 Oct 2013 22:21:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Aurelien Jarno <aurel32@debian.org>:
New Bug report received and forwarded. Copy sent to Debichem Team <debichem-devel@lists.alioth.debian.org>. (Tue, 29 Oct 2013 22:21:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Aurelien Jarno <aurel32@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: FTBFS on mips, mipsel and s390x due to -Werror=format-security
Date: Tue, 29 Oct 2013 23:16:58 +0100
Package: mpqc
Version: 2.3.1-15
Severity: serious
Tags: patch upstream
Justification: fails to build from source (but built successfully in the past)

mpqc fails to build from source on mips, mipsel and s390x due to the
following error:

| atominfo.cc: In member function 'int sc::AtomInfo::string_to_Z(const string&, int)':
| atominfo.cc:496:75: warning: deprecated conversion from string constant to 'char*' [-Wwrite-strings]
|        ExEnv::err0() << sprintf("AtomInfo: invalid name: %s\n",name.c_str());
|                                                                            ^
| atominfo.cc:496:75: error: format not a string literal and no format arguments [-Werror=format-security]
| cc1plus: some warnings being treated as errors

Strangely this doesn't happen on other architectures where only the first warning is printed

| atominfo.cc: In member function 'int sc::AtomInfo::string_to_Z(const string&, int)':
| atominfo.cc:496:75: warning: deprecated conversion from string constant to 'char*' [-Wwrite-strings]

Looking at the (very weird) code, the error is obviously valid:

|      ExEnv::err0() << sprintf("AtomInfo: invalid name: %s\n",name.c_str());

Considering I understood what the upstream author wanted to do, here is
a patch to fix the issue:

--- mpqc-2.3.1.orig/src/lib/chemistry/molecule/atominfo.cc
+++ mpqc-2.3.1/src/lib/chemistry/molecule/atominfo.cc
@@ -493,7 +493,7 @@ AtomInfo::string_to_Z(const std::string
   if (iname != symbol_to_Z_.end()) return iname->second;

   if (allow_exceptions) {
-      ExEnv::err0() << sprintf("AtomInfo: invalid name: %s\n",name.c_str());
+      ExEnv::err0() << ("AtomInfo: invalid name: " + name + "\n").c_str();
       throw std::runtime_error("invalid atom name");
     }

-- System Information:
Debian Release: jessie/sid
  APT prefers unstable
  APT policy: (500, 'unstable')
Architecture: mipsel (mips64)

Kernel: Linux 3.2.0-4-5kc-malta
Locale: LANG=fr_FR.UTF-8, LC_CTYPE=fr_FR.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash



Reply sent to Michael Banck <mbanck@debian.org>:
You have taken responsibility. (Wed, 27 Nov 2013 10:51:12 GMT) Full text and rfc822 format available.

Notification sent to Aurelien Jarno <aurel32@debian.org>:
Bug acknowledged by developer. (Wed, 27 Nov 2013 10:51:12 GMT) Full text and rfc822 format available.

Message #10 received at 728249-close@bugs.debian.org (full text, mbox):

From: Michael Banck <mbanck@debian.org>
To: 728249-close@bugs.debian.org
Subject: Bug#728249: fixed in mpqc 2.3.1-16
Date: Wed, 27 Nov 2013 10:49:10 +0000
Source: mpqc
Source-Version: 2.3.1-16

We believe that the bug you reported is fixed in the latest version of
mpqc, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 728249@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Michael Banck <mbanck@debian.org> (supplier of updated mpqc package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Wed, 27 Nov 2013 10:53:11 +0100
Source: mpqc
Binary: mpqc mpqc-openmpi libsc-dev libsc7 libsc-data libsc-doc mpqc-support
Architecture: source amd64 all
Version: 2.3.1-16
Distribution: unstable
Urgency: low
Maintainer: Michael Banck <mbanck@debian.org>
Changed-By: Michael Banck <mbanck@debian.org>
Description: 
 libsc-data - Scientific Computing Toolkit (basis set and atom data)
 libsc-dev  - Scientific Computing Toolkit (development files)
 libsc-doc  - Scientific Computing Toolkit (documentation)
 libsc7     - Scientific Computing Toolkit (library)
 mpqc       - Massively Parallel Quantum Chemistry Program
 mpqc-openmpi - Massively Parallel Quantum Chemistry Program (OpenMPI transitiona
 mpqc-support - Massively Parallel Quantum Chemistry Program (support tools)
Closes: 728249
Changes: 
 mpqc (2.3.1-16) unstable; urgency=low
 .
   * debian/patches/16_format-security.patch: New patches, fixes a FTBFS error
     on mpich arches, by Aurelien Jarno; closes: #728249.
Checksums-Sha1: 
 e2bd22d0cc94f137b8ddb52004593ace6f002cb4 1629 mpqc_2.3.1-16.dsc
 7fbe8444968d3f6e5521a724860d8c59e5f58e81 32716 mpqc_2.3.1-16.debian.tar.gz
 6785f6d85408c24e78fe959e6f22f79a289c54b9 88142 mpqc_2.3.1-16_amd64.deb
 b2e4b8fb63b1c01666a2ff1cbe3cf976150dd721 14994 mpqc-openmpi_2.3.1-16_all.deb
 70840a746c3301a27cbf38e8ba0955041f399ac0 241578 libsc-dev_2.3.1-16_amd64.deb
 376641dba6dca34989dc32e0a55fc8a09d2addfd 2382820 libsc7_2.3.1-16_amd64.deb
 bbe06b055a6f2c4b82a89f01f13888e591b1d807 120536 libsc-data_2.3.1-16_all.deb
 b14d28439f50158473b09400a4afea9ac63f81f6 2527654 libsc-doc_2.3.1-16_all.deb
 b42e0e723dfae3c9d2c7406da41490112c12cc4e 676110 mpqc-support_2.3.1-16_amd64.deb
Checksums-Sha256: 
 de61051aa6f2ce59704d78e6f8cb1a315764bf2e519d9f867df10ddd6a602318 1629 mpqc_2.3.1-16.dsc
 2c1a57cb5ff1f536072c3dc222b7d860f3a5dd06e437aaa33d92a62eaa8ebb52 32716 mpqc_2.3.1-16.debian.tar.gz
 8000780462e28f8125a9760f75252b9e39a0282ba00a8f1dd653b64748a5bae3 88142 mpqc_2.3.1-16_amd64.deb
 94e9fceaabd05027d35cd487b010b3c200a9b16fc3ac12fa9d96b1acea6d0f8b 14994 mpqc-openmpi_2.3.1-16_all.deb
 a462024340850491bae61e3d2e64000f65d7b69a469f1e642ae9b5363ff54653 241578 libsc-dev_2.3.1-16_amd64.deb
 fd618a242f3c6d34549d6c0d7e16b9b214d03eb8d6ba1009a2f921b2147959cc 2382820 libsc7_2.3.1-16_amd64.deb
 f56751a0fc60f448387e002393bfbdffbadf1994421949e07baa1e316a565c4f 120536 libsc-data_2.3.1-16_all.deb
 f6f809b468c209f54257d314389dc04583824021a460a82086e94c2eef697a3d 2527654 libsc-doc_2.3.1-16_all.deb
 3e79ad39f68cc7dc9cb1f8e0e32ec99d094d0bcf0f00ac85e80095a680a33c95 676110 mpqc-support_2.3.1-16_amd64.deb
Files: 
 95ea1912d5e9252fc2320ebed9ff5482 1629 science optional mpqc_2.3.1-16.dsc
 5e1a5c0b9c719b062083fd2a787cf866 32716 science optional mpqc_2.3.1-16.debian.tar.gz
 875c45024a747238b03e4d808344c25e 88142 science optional mpqc_2.3.1-16_amd64.deb
 8b68c4e541304a01e108462e1a993459 14994 oldlibs extra mpqc-openmpi_2.3.1-16_all.deb
 918a9fcb94d572915a94026cf1c75799 241578 libdevel optional libsc-dev_2.3.1-16_amd64.deb
 5de768cd069ad97ca894e02a4d0989b3 2382820 libs optional libsc7_2.3.1-16_amd64.deb
 102dd0fbacf0402560a5636924705f29 120536 libs optional libsc-data_2.3.1-16_all.deb
 4e078168d49d9c84100438ed58a02176 2527654 doc optional libsc-doc_2.3.1-16_all.deb
 bb6e4e3251b530f5a9c2252de771ca5c 676110 science optional mpqc-support_2.3.1-16_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAlKVy+sACgkQmHaJYZ7RAb8owQCfcKUQL+wcOQazzRyhHAXEG6sF
SLgAoJta0UpmHSlaUXg25AhaDCqcgCzf
=ngrY
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 26 Dec 2013 07:31:05 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 23:22:24 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.